Index: trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc	(revision 8938)
+++ trunk/MagicSoft/Mars/mjobs/MJSpectrum.cc	(revision 8940)
@@ -1263,5 +1263,5 @@
             // Don't do this on the original object!
             histsel->SetStats(kFALSE);
-
+          /*
             fLog->Separator("Kolmogorov Test");
             histsel->KolmogorovTest(excess, "DX");
@@ -1272,4 +1272,5 @@
             tex.SetBit(TLatex::kTextNDC);
             tex.DrawLatex(0.75, 0.93, Form("P(\\chi^{2})=%.0f%%", p*100));
+           */
         }
     }
@@ -1388,4 +1389,26 @@
     hist.InitTitle(";Slope;Disp-Dist [\\circ];");
     hist.SetDrawOption("colz profx");
+}
+
+void MJSpectrum::SetupHistEnergyRes(MHn &hist) const
+{
+    hist.AddHist("MEnergyEst.fVal", "(MMcEvt.fEnergy/MEnergyEst.fVal-1)^2", MH3::kProfile);
+    hist.InitName("ResEest;EnergyEst;");
+    hist.InitTitle(";E_{est} [GeV];Resolution (E_{mc}/E_{est}-1)^{2};");
+
+    //hist.AddHist("MMcEvt.fEnergy", "(MEnergyEst.fVal/MMcEvt.fEnergy-1)^2", MH3::kProfile);
+    //hist.InitName("ResEmc;EnergyEst;");
+    //hist.InitTitle(";E_{mc} [GeV];Resolution (E_{est}/E_{mc}-1)^{2};");
+    hist.AddHist("MHillas.fSize", "(MMcEvt.fEnergy/MEnergyEst.fVal-1)^2", MH3::kProfile);
+    hist.InitName("ResSize;Size;");
+    hist.InitTitle(";S [phe];Resolution (E_{mc}/E_{est}-1)^{2};");
+
+    hist.AddHist("MPointingPos.fZd", "(MMcEvt.fEnergy/MEnergyEst.fVal-1)^2", MH3::kProfile);
+    hist.InitName("ResTheta;Theta;");
+    hist.InitTitle(";\\Theta [\\circ];Resolution (E_{mc}/E_{est}-1)^{2};");
+
+    hist.AddHist("MMcEvt.fImpact/100", "(MMcEvt.fEnergy/MEnergyEst.fVal-1)^2", MH3::kProfile);
+    hist.InitName("ResImpact;Impact;");
+    hist.InitTitle(";I [m];Resolution (E_{mc}/E_{est}-1)^{2};");
 }
 
@@ -1533,5 +1556,5 @@
     GetThetaDistribution(htheta, hist);
 
-    // Give the zenoith angle weights to the weighting task
+    // Give the zenith angle weights to the weighting task
     weight.SetWeightsZd(&htheta);
 
@@ -1634,4 +1657,5 @@
     MBinning binsB(51, -1, 1,      "BinningEnergyResidual", "lin");
     MBinning binsD(51, -1, 1,      "BinningResidualDist",   "lin");
+    MBinning binsI(16,  0, 800,    "BinningImpact",         "lin");
 
     plist.AddToList(&binsA);
@@ -1639,4 +1663,5 @@
     plist.AddToList(&binsC);
     plist.AddToList(&binsD);
+    plist.AddToList(&binsI);
 
     MHn heest("Energy", "Energy Residual (lg E_{est} - lg E_{mc})");
@@ -1649,4 +1674,7 @@
     SetupHistEvtDist(henergy);
 
+    MHn heres("EnergyRes");
+    SetupHistEnergyRes(heres);
+
     MFillH fill4b(&heest, "", "FillEnergyResidual");
     fill4b.SetWeight();
@@ -1654,4 +1682,7 @@
     MFillH fill4c(&hdisp, "", "FillDispResidual");
     fill4c.SetWeight();
+
+    MFillH fill4d(&heres, "", "FillEnergyResolution");
+    fill4d.SetWeight();
 
     MFDataPhrase fdisp("Disp.fVal*sign(MHillasSrc.fCosDeltaAlpha)<0", "FilterDisp");
@@ -1745,4 +1776,5 @@
     tlist2.AddToList(&fill4);
     tlist2.AddToList(&fill4b);
+    tlist2.AddToList(&fill4d);
     tlist2.AddToList(&fill5);
     tlist2.AddToList(&fill0a);
@@ -1818,4 +1850,6 @@
         return kTRUE;
 
+    TNamed ganame("ganymed.root", gSystem->BaseName(fPathIn));
+
     // Write the output
     TObjArray cont;
@@ -1826,4 +1860,5 @@
     cont.Add(&area1);
     cont.Add(&hest);
+    cont.Add(&ganame);
 
     if (fDisplay)
Index: trunk/MagicSoft/Mars/mjobs/MJSpectrum.h
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJSpectrum.h	(revision 8938)
+++ trunk/MagicSoft/Mars/mjobs/MJSpectrum.h	(revision 8940)
@@ -43,4 +43,5 @@
     void SetupHistEnergyEst(MHn &hist) const;
     void SetupHistDisp(MHn &hist) const;
+    void SetupHistEnergyRes(MHn &hist) const;
 
     // Read Input
Index: trunk/MagicSoft/Mars/mjobs/MJStar.cc
===================================================================
--- trunk/MagicSoft/Mars/mjobs/MJStar.cc	(revision 8938)
+++ trunk/MagicSoft/Mars/mjobs/MJStar.cc	(revision 8940)
@@ -478,4 +478,5 @@
     MFillH fillw2("MHWeather", "MTimePyrometer", "FillPyrometer");
     fillw2.SetBit(MFillH::kDoNotDisplay);
+    fillw2.SetBit(MFillH::kCanSkip);
 
     // instantiate camera histogram containers